#include <gtk/gtk.h>

/*
 * based on http://developer.gnome.org/gtk-tutorial/2.90/c39.html
 */

static gboolean delete_event( GtkWidget *widget,
		GdkEvent  *event,
		gpointer   data )
{
	gtk_main_quit();

	return FALSE;
}

static void destroy(GtkWidget *widget, gpointer data )
{
	gtk_main_quit();
}

gint timeout_callback(gpointer data)
{
	gtk_main_quit();
	return FALSE;
}

int display(const char *text, unsigned int timeout)
{
	GtkWidget *dialog;

	gtk_init(NULL, NULL);

	dialog = gtk_message_dialog_new(NULL,
			GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_MESSAGE_INFO,
			GTK_BUTTONS_CLOSE,
			"%s", text);

	g_signal_connect(dialog, "delete-event", G_CALLBACK (delete_event), NULL);

	g_signal_connect(dialog, "destroy", G_CALLBACK (destroy), NULL);

	g_signal_connect_swapped(dialog, "response", G_CALLBACK(gtk_widget_destroy),
			dialog);

	gtk_widget_show(dialog);

	if (timeout)
		g_timeout_add_seconds(timeout, timeout_callback, NULL);

	gtk_main();

	return 0;
}
